/* magicd.c -- Magic C++ telnet server process
   (Mostly) portable public-domain implementation
   -- Copyright(C) 2003 Magicunix Infomation Technology Limited 
   This file is part of magicd.
   magicd is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
	 
   For details, see the Magic C++ World-Wide-Web page, 
   `http://www.magicunix.com',
   or send a mail to the Magic C++ developers <support@magicunix.com>.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <tcp.h>
#include <errno.h>
#include "tools.h"
#include "ip.h"
#include "fmt.h"
#include "login.h"
#include "telnet.h"
#define BUILD "050612"
 
#define _GNU_SOURCE
#include <getopt.h>
#include "info.h"  /*this file is generated by Makefile dynamically,it's include prefix dir*/


static char *copyright=
"@(#) magicd 3.0.0 Copyright (c)2003 MagicUnix infomation Technology, All rights reserved.\n";

int getclientip(int fd , struct sockaddr_in	*pcliaddr , int * pcliaddrlen , char *ip);
int setup(char *argv[],struct passwd *pw);
void sync_rw(int sockfd, int streamfd ,char * clientip);
struct passwd * login_auth_sys(int fd, char *clientip);
void util_byte_copy(register char *to,
	register unsigned int n,register char *from);
int clearuputmpx();
int release_licencecnt();

extern void outa_here(), daemonize();
int tty_getmode(int fd);
void  relief();
void killed( int sig );
char *addr2host();
int print_usage();
extern int errno;

int childpid=0, newfd;
int	netdebug=0, telnet=0; 
int	login=0;  /*type of login ,0 for normal login , 1 for express login*/
int telnet_col = 300;  /*default value for the term columns*/
int telnet_row = 300;  /*default value for the term rows*/
int port = 2004;       /*default value for port*/
int http_port = 2104;  /*default port for http server*/
char logname_var[100];     /*login program name*/
char szNoRootUsername[50];  /*user-defined user name*/
char szNoRootPasswd[50];    /*user-defined pass word*/


int debug = 0;
int doutmp = 0;

#define MAXKIDS	256		/* The absolute maximum forked processes */
int children[MAXKIDS];		/* Forked processes handling tcp connections */
static int maxkids=0;		/* The maximum number of forked processes */
extern char clientip[16];
extern int getlicence;
char    remotehost[64];
int fd;

int main(int argc,char *argv[])
{  
	extern char		*optarg;
	extern int 		optind, errno;
	int			    streamfd, clilen;
	int			    i,  found;
	char		    *ptr, *args[256];
	struct passwd   *pw=NULL;
	struct sockaddr_in	cli_addr, serv_addr;
	int one = 1;	
	pid_t pid;
	int status;
	char prompt[100];
	int express;
	char newprompt[100];
	
	uid_t uid;
	int optch;
	int longindex;
	static char optstring[] = "p:L:a:f:hvdc:r:t:";
	static struct option long_opts[] = {
		{"help" , 0 , 0 , 'h' },
		{"version" , 0 , 0 , 'v'},
		{"debug" , 0 , 0 , 'd'},
		{"col" , 0 , 0 , 'c'},
		{"row" , 0 , 0 , 'r'},
		{"httpport" , 0 , 0 , 't'},  /*http ˿ں*/
		{0 , 0 , 0 , 0}
	};
	char cmdLine[300];
	telnet = 1;
	memset( logname_var , 0 , sizeof( logname_var ));
	memset( szNoRootUsername , 0 , sizeof(szNoRootUsername ));
	memset( szNoRootPasswd , 0 , sizeof(szNoRootPasswd ));
	memset( cmdLine , 0 , sizeof(cmdLine ));
	strcpy(logname_var , LOGIN);  /*default login name, search by configure*/
	for(i = 0 ; i < argc ; i++)
	{      
		strcat(cmdLine , argv[ i ]);
		strcat(cmdLine , " " );
	}
	
	/*check command line*/
	while( (optch = getopt_long( argc , argv , optstring , long_opts , &longindex) ) != -1 )
	{
		char *p1;
		char szTemp[ 100 ];
		char szIniFile[ 200 ];
		int nSkipAll = 0;  /*-f for skip other arguments...*/
		memset(szIniFile , 0 , sizeof(szIniFile));
		switch( optch )
		{
		case 'f':  /*load arguments from file*/
			
			strcpy(szIniFile , optarg );
			util_trim( szIniFile );
			if( strlen( szIniFile ) == 0 )
			{
				print_usage();
				exit( -3 );
			}
			if( szIniFile[ 0 ] != '/' )  /*it is not absolute path*/
			/*using current directory as base directory*/
			{
				char szTemp[ 200 ];
				
				memset( szTemp , 0 , sizeof( szTemp ));
				if( getcwd( szTemp , sizeof( szTemp ) ) == 0 )
				{
					printf("get current working directory failed!\n");
					util_err_log("magicd: get current working directory failed!" , __FILE__ , __LINE__ , errno);
					exit( -4 );
				}
				
				if( szTemp[ strlen(szTemp) - 1 ] != '/')
					strcat( szTemp , "/" );
				
				strcat( szTemp , szIniFile );
				
				memset( szIniFile , 0 , sizeof(szIniFile));
				strcpy( szIniFile , szTemp );
			}
			if ( load_inifile(szIniFile) == -1 )
			{
				printf("get infomation from %s failed , please check it!" , szIniFile);
				exit( -4 );
			}
			
			nSkipAll = 1;
			break;
			
		case 'p':
			port  = atoi( optarg );
			if( port <= 0 )
			{
				print_usage();
				exit( -3 );
			}
			break;
		case 'c':
			telnet_col  = atoi( optarg );
			if( telnet_col <= 0 )
			{
				print_usage();
				exit(-3 );
			}
			break;
		case 'r':
			telnet_row  = atoi( optarg );
			if( telnet_row <= 0 )
			{
				print_usage();
				exit(-3 );
			}
			break;
		case 'L':
			strcpy( logname_var  , optarg );
			if( logname_var[ 0 ] != '/' )
			{
				print_usage();
				exit(-3 );		
			}
			break;
		case 'a':
			/*get user name setup by user himself*/
			memset(szTemp , 0 , sizeof(szTemp));
			memset(szNoRootUsername , 0 , sizeof(szNoRootUsername));
			memset(szNoRootPasswd , 0 , sizeof(szNoRootPasswd));
			strcpy(szTemp , optarg);
			if(debug)
				printf("optarg=%s\n", optarg);
			util_trim( szTemp );
			if(debug)
				printf("username/password=%s\n", szTemp);
			p1 = strchr( szTemp , ',' );
			if( p1 == NULL )
				p1 = strchr( szTemp , ',' );
			if( p1 == NULL )
				strcpy( szNoRootUsername ,szTemp );
			else
			{
				
				strncpy(szNoRootUsername , optarg , p1 - szTemp );
				if(debug)
                                	printf("username=%s\n" , szNoRootUsername);
				strcpy(szNoRootPasswd , p1 + 1 );
				if(debug)
	                        	printf("password=%s\n" , szNoRootPasswd);
			}
			login = 1;  /*this means using self-verify*/
			break;
		case 'h':
			print_usage();
			exit( -3 );
		case 'v':
			printf("verion=%sbuild%s\n" , VERSION , BUILD);
			exit( -3 );
		case 'd':
			debug = 1;
			break;
		case 't':
			http_port  = atoi( optarg );
			if( http_port <= 0 )
			{
				print_usage();
				exit(-3 );
			}
			break;
			
		
		default :
			print_usage();
			exit(-3);
		}
		if( nSkipAll ) 
			break;
	}
	printf("Starting Magic C++ server daemon program...\n");
	printf("Installation directory is :%s \n",szInstallDir );
	if( debug )
		printf("Login program on the host is :%s\n", logname_var );

	if( login == 0 && getuid() != 0 )
	{
		printf( "You don't have the superuser privilege!please using the argument '-a' to define user name and password\n");
		print_usage();
		exit(3);
	}
	
	/*start up http server*/
	printf("Starting up http server on port [%d]\n" , http_port);
	if ( (pw = (struct passwd *)getpwuid(getuid())) == NULL )
	{
		perror("getpwuid() failed!\n");
		exit( -1 );
	}
	if(debug)
	
		printf("user name is :%s\n" , pw->pw_name);
	if(( pid = fork())<0)
		perror("fork error\n");
	else if( pid == 0)
	{
		char szPathName[200];
		char szPath[ 200 ];
		char szHTTP_port[50];
		struct passwd *pwTmp;
		memset(szPath , 0 , sizeof(szPath));
		memset(szPathName , 0 , sizeof(szPathName));
		memset(szHTTP_port , 0 , sizeof(szHTTP_port));
		errno = 0;
		sprintf(szPath , "%s/thttpd" , szInstallDir);
		if( chdir(szPath) ==  -1 )
		{
			perror("chdir() failed!\n");
			exit( -1 );
		}
		sprintf(szPathName , "%s/thttpd/mchttpd" , szInstallDir);
		sprintf(szHTTP_port , "%d" , http_port); 
		/*get current user name*/

		if( execl( szPathName ,"mchttpd" , "-p" , szHTTP_port , "-c" , "/cgi-bin/*" , "-u" , pw->pw_name , (char*)0 )< 0)
		{
			
			perror( "Startup http server failed!execl failed\n");
			
		}
	}
	waitpid(pid ,&status , 0 );
	if( WIFEXITED(status) )
	{
		if( ( errno =  WEXITSTATUS(status) ) !=0 )
		{
			perror("Startup http server failed!\n");
			
		}
	}
	else if( WIFSIGNALED(status) )
	{
		perror("Startup http server failed!\n");
		
	}
	args[ 0 ] = (char *)malloc(strlen( logname_var ) + 1 );
	if( !args[ 0 ] )
	{
		
		printf("Malloc error\n");
		exit(2);
	}
	strcpy(args[0] ,  logname_var);
	args[ 1 ] = NULL;
 
	/* Set up tty modes for the pty */
	(void) tty_getmode(0);

	/*
	 * Open a TCP socket (an Internet stream socket).
	 */

	if ( (fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		printf("Can't open stream socket\n");
		exit(3);
	}
		/*
	 * Bind our local address so that the client can send to us.
	 */

	d_zero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family      = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port        = htons(port);
    if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(one))) 
    {
       	printf("Can't reuse local address...\n");
		exit(3);
    }
    /*
    if (setsockopt(fd, SOL_SOCKET, SO_REUSEPORT, &one, sizeof(one))) 
    {
       	printf("Can't reuse local port...\n");
		exit(3);
    }
	*/
	if (bind(fd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) 
	{
		printf("Can't bind local address...\n");
		exit(3);
	}

	if ( listen(fd, 3) < 0 ) 
	{
		printf("listen() error\n");
		/*util_sem_remove();*/
		exit(3);
	}

	/* Run as a daemon, if desired. */
	printf("Magic C++ server daemon has been started successfully on port [%d]...\n",port );
	
	printf("Copyright(c) 2004-2005 MagicUnix Information Technology Limited. All rights reserved\n");
	daemonize();
	util_log("System startup successfully on port:%d...\n",port);
	util_log("Magicd startup command:%s\n",cmdLine);
	/*init ipcs*/
	/*
	if( util_ipc_init() == -1 )
	{
		util_err_log("IPC Initialize failed!\n",__FILE__,__LINE__,errno );
		exit( 3 ); 
	}
	util_log("Initialize IPC successfully...\n");*/
	signal(SIGPIPE, SIG_IGN);	/* Don't die on broken connections */


	
/*#if defined(SOLARIS)  || defined( FREEBSD )*/
	if( signal( SIGCHLD , relief ) == SIG_ERR )
	{
		util_err_log( "Can not signal!\n",__FILE__,__LINE__,errno);
		exit(3);
	}
	
	
	/*
#else
	if( signal( SIGCLD , SIG_IGN ) == SIG_ERR )
	{
		util_err_log( "Can not signal!\n",__FILE__,__LINE__,errno);
		exit(3);
	}
#endif
*/
	if( signal( SIGTERM , killed ) == SIG_ERR )
	{
		util_err_log( "Can not catch SIGTERM!\n",__FILE__,__LINE__,errno);
		exit(3);
	}
	for ( ; ; ) 
	{
		/*
		 * Wait for a connection from a client process.
		 * This is an example of a concurrent server.
		 */

		clilen = sizeof(cli_addr);
		if ((newfd=accept(fd, (struct sockaddr *)&cli_addr, &clilen))<0)
		{
			if ( errno == EINTR )
				continue;
			else {
				util_log("accept() error\n");
				/*util_sem_remove();*/
				exit(3);
			}
		}
		/*record ip infomation*/
		clilen = sizeof(cli_addr);
		memset( clientip , 0 , sizeof( clientip ));
		if( getclientip( newfd , &cli_addr , &clilen , clientip) == -1)
			
		{
			util_err_log( "Can not get peer ip!",__FILE__,__LINE__,errno );
			/*util_sem_remove();*/
			exit(3);
		}
		util_log( "client IP address: %s come!\n",clientip);
		
		(void) addr2host((struct sockaddr *)&cli_addr, remotehost);
		
		
		/* Check to see if we can fork */

		if ( maxkids ) 
		{
			for ( i=0, found=0; i<maxkids; ++i )
			{
				/*kill(children[i], 0 < 0)  Ƿ*/
				if ( !children[i] || kill(children[i], 0 < 0) )
				{
					found=1;
					break;
				} 
			}
			if ( ! found )
			{  /* We had too many children already */
				ptr="Server busy.  Please try again later.\r\n";
				write(newfd, ptr, strlen(ptr));
				util_err_log( ptr , __FILE__,__LINE__ , errno );
				close(newfd);
				continue;
			}
		}

		if ( (childpid = fork()) < 0)
		{

			if ( errno == EAGAIN )
			{
				ptr="Can't fork.  Try again later.\r\n";
				write(newfd, ptr, strlen(ptr));
				util_err_log( ptr , __FILE__,__LINE__ , errno );
				close(newfd);
				continue;
			}
			else {
				perror("fork() error");
				util_err_log( ptr , __FILE__,__LINE__ , errno );
				exit(3);
			}
		}
		else if (childpid == 0) 
		{	/* child process */
			/*sco CC will change the point , I don't know why*/
			char *p = args[ 0 ];
			close(fd);  
			if ( telnet )
				express = init_telnet(newfd, 1 ,clientip );
   			args[ 0 ] = p;
			/* Do login authentication if desired */
   			memset( newprompt , 0 , sizeof( newprompt ));
			/*nomal login (not magic c++ frontend) and self-verify*/
			if ( login == 1 && express == 0 )
			{
				/*startup the default shell of that user who startup daemon programme*/
				free( args[ 0 ] );
				args[ 0 ] = 0;
				if ( (pw = (struct passwd *)login_auth(newfd,clientip,
					szNoRootUsername , szNoRootPasswd)) == NULL)
				{
					util_log("non root login failed!\n");
					util_log("The client :%s has left\n",clientip );
					close(newfd);
					exit(0);				
				}
			}
			/*express login and verify username by system*/
			else if(  express == 1 && login == 0 )
			{
				free( args[ 0 ]);
				args[ 0 ] = 0;
				util_log("Begin express normal login... \n");
				if( ( pw = (struct passwd *)login_express( newfd , newprompt ,clientip)) == NULL )
				{
					util_log("Expression login failed!\n");
					util_log("The client :%s has left\n",clientip );
					close(newfd);
					exit(0);	
				}
			}
			/*express login and self-verify*/
			else if( express == 1 && login == 1 )
			{
				free( args[ 0 ]);
				args[ 0 ] = 0;
				util_log("Begin express backdoor login... \n");
				if( ( pw = (struct passwd *)login_express_backdoor( newfd , newprompt
					,clientip , szNoRootUsername , szNoRootPasswd ) ) == NULL )
				{
					util_log("Backdoor expression login failed!\n");
					util_log("The client :%s has left\n", clientip );
					close( newfd );
					exit(0);
				}
			}
			else if( express == 0 && login == 0 )
			{
				free( args[ 0 ]);
				args[ 0 ] = 0;
				util_log("Begin normal login... \n");
				if( ( pw = (struct passwd *)login_auth_sys( newfd  ,clientip)) == NULL )
				{
					util_log("Expression login failed!\n");
					util_log("The client :%s has left\n",clientip );
					close(newfd);
					exit(0);	
				}
			}
		
			/* Set up the pty and shell */
			if ( (streamfd=setup(args, pw)) < 0 )
			{
				util_err_log( "setup error" , __FILE__,__LINE__ , errno );
				exit(0);
			}
			
			/* redirect stderr to newfd */
			close(2);  dup(newfd);
			close(0);  close(1);

			/*change command line prompt*/
			if( express )
			{
				memset( prompt , 0 , sizeof( prompt ));
				ret_command_prompt(newfd , streamfd , clientip ,newprompt , pw);
			}
			/* sync read/write the fd's */
			sync_rw(newfd, streamfd , clientip );   /* process the request */
#ifdef OLDDEBUG
			fprintf(stderr, "sync-rw() returned.\n");
#endif
			/*clear up utmpx*/
#ifdef HAVE_UTMPX_H
			clearuputmpx();
#endif
			
			util_log("The client :%s has left\n",clientip );
			/*
			if( getlicence )
				release_licencecnt(clientip);
			*/
			outa_here();
		}
 
		close(newfd);		/* parent process */
		/*children[i]=childpid;*/
	}
}

 
/* A function to prevent zombie processes from clogging the system */

void relief(sig)
int sig;
{
	int child_status;
	int flags = WNOHANG|WUNTRACED;
	util_log("A children dead abnormal!\n");
    while (waitpid(-1, &child_status, flags) > 0)
         ;   /* VOID */

	if( signal( SIGCHLD , relief ) == SIG_ERR )
	{
		util_err_log( "Can not signal!\n",__FILE__,__LINE__,errno);
		exit(3);
	}	

}

void killed(int sig)
{
	util_log("Main Program has been killed!\n");
	close( fd );
	exit( 0 );
}
/* A function to convert a sockaddr_in structure to its corresponding
   hostname (or its IP address if the hostname can't be found)  
*/

char *addr2host(addrptr, host)
struct sockaddr *addrptr;
char *host;
{
	struct in_addr peeraddr;        /* The address of the connector */
	struct hostent *hp;
	int i;
	char *ptr, tmp[12];


	/*
         * The set of four bytes in the third buffer position are
         * the 32 bit ip address of the connector.
         */

        d_copy((&(addrptr->sa_data[2])), (char *)(&peeraddr.s_addr),
                                                sizeof(peeraddr.s_addr));
	
	/* Look up the address in the host tables */
	if ( (hp=gethostbyaddr((char *)(&peeraddr.s_addr),
                                sizeof(peeraddr.s_addr), AF_INET)) == NULL )
	{
		/* Convert it to a dot-ip address */
		*host='\0';
		for ( i=0, ptr=(char *)&peeraddr.s_addr; i<3; ++i, ++ptr )
		{
			sprintf(tmp, "%d.", 
				((int)*ptr < 0)?((int)*ptr+256):(int)*ptr);
			strcat(host, tmp);
		} 
		sprintf(tmp, "%d", ((int)*ptr < 0)?((int)*ptr+256):(int)*ptr);
		strcat(host, tmp);
	}
        else
                strcpy(host, hp->h_name);

	return(host);
}


int getclientip(int fd , struct sockaddr_in	*pcliaddr , int * pcliaddrlen , char *ip)
{
	struct	ip_address ipremote;
	if ( getpeername(fd,(struct sockaddr *)pcliaddr,pcliaddrlen) == -1 )
		return -1;
	util_byte_copy((char *)&ipremote,4,(char *)&pcliaddr->sin_addr);
	ip[ip_fmt(ip,&ipremote)] = '\0';
	return 0;
}

int print_usage()
{
	printf("Usage : magicd [-p port] [-t http_port] [-f FILE] [-L FILE] [-a USERNAME , PASSWORD]  [--help] [--version] [--col ] [--row ] [--debug]\n");
	printf("for more infomation , see doc/magicd.texi\n");
}

/*using -f argument and load configurations from ini file*/
int load_inifile(char *inifile)
{
	int nValue;
	char szValue[200];
	
	/*get port*/
	if( util_getinfo_int( "COMMON" , "port" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get port infomation!, please check file :%s\n" , inifile);
	else
		port = nValue;
	if( util_getinfo_int( "COMMON" , "http_port" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get HTTP port infomation!, please check file :%s\n" , inifile);
	else
		port = nValue;		
	/*get login program*/
	if( util_getinfo_str( "COMMON" , "login" , szValue , inifile ) == -1 )
		/*printf("Warning : Can not get login program infomation!, please check file :%s\n" , inifile )*/;	
	else
		strcpy( logname_var , szValue );
	
	/*get debug*/
	if( util_getinfo_int( "COMMON" , "debug" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get debug infomation!, please check file :%s\n" , inifile );
	else
		debug = nValue;
		
	/*get column number*/
	if( util_getinfo_int( "WINSZ" , "col" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get column infomation!, please check file :%s\n" , inifile );
	else
		telnet_col = nValue;
	
	/*get row number*/
	if( util_getinfo_int( "WINSZ" , "row" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get row infomation!, please check file :%s\n" , inifile );
	else
		telnet_row = nValue;
	
	/*is user-defined verify?*/
	if( util_getinfo_int( "SELF_AUTH" , "self auth" , &nValue , inifile ) == -1 )
		printf("Warning : Can not get auth infomation!, please check file :%s\n" , inifile );
	else 
		login = nValue;
	
	if( login == 1)  /*express login*/
	{
		/*read in the user name and password*/
		memset( szValue , 0 , sizeof( szValue ));
		if( util_getinfo_str( "SELF_AUTH" , "username" , szValue , inifile ) == -1 )
		{
			printf("Error : Can not get user name , please check file :%s\n" , inifile );
			exit( -4 );
		}
		else
			strcpy( szNoRootUsername , szValue );
		memset( szValue , 0 , sizeof( szValue ));
		if( util_getinfo_str( "SELF_AUTH" , "password" , szValue , inifile ) == -1 )
		{
			printf("Error : Can not get password , please check file :%s\n" , inifile );
			exit( -4 );
		}
		else
			strcpy( szNoRootPasswd , szValue );
	}
	return 0;
}

